/*
 * man.c
 *
 *  Created on: 1.9.2011
 *      Author: emlin
 */

# include "../led4x/led4x-ioctl.h"
#include <unistd.h>
#include <fcntl.h>
#include <sys/types.h>
#include <stdlib.h>
#include <stdio.h>
#include <errno.h>
#include <string.h>
#include <sys/ioctl.h>

// -----------------------------------------------------------------------------
int main(int argc, char ** argv)
{
	int result = EXIT_FAILURE, sysRes = 0;
	int drvHandle = -1;
	int value, period, tmpVar;

	// overime a prelozime vstupni data
	if ( argc < 3 )
	{
		printf("Malo vstupnich argumentu!\n");
		goto End;
	}
	value = atoi(argv[1]);
	period = atoi(argv[2]);
	printf("LEDky = %d, perioda[ms] = %d\n", value, period);

	// zkusime otevrit soubor zarizeni
	drvHandle = open("/dev/led4x", O_RDWR);
	if ( drvHandle < 0 )
	{
		printf("Ovladac nelze otevrit! Chyba(%d): '%s'\n",
			   drvHandle, strerror(errno));
		goto End;
	}

	// zapiseme hodnotu do LEDek
	sysRes = write(drvHandle, &value, 1);
	if ( sysRes <= 0 )
	{
		printf("Zapis hodnoty do LEDek selhal! Chyba: '%s'\n", strerror(errno));
		goto End;
	}

	// nastavime periodu blikani
	sysRes = ioctl(drvHandle, LED4X_SET_PERIOD, &period);
	if ( sysRes < 0 )
	{
		printf("Zapis periody selhal! Chyba: '%s'\n", strerror(errno));
		goto End;
	}

	// zapneme blikani
	tmpVar = 1;

	sysRes = ioctl(drvHandle, LED4X_EN_BLINKING, &tmpVar);
	if ( sysRes < 0 )
	{
		printf("Zapnuti blikani selhalo! Chyba: '%s'\n", strerror(errno));
		goto End;
	}

	// cekam na stisk libovolne klavesy, pak ukoncime blikani
	printf("Stiskem 'Enter' ukoncite blikani...\n");
	while ( getchar() == EOF );

	result = EXIT_SUCCESS;

End:
	// zavreme soubor zarizeni
	if ( drvHandle >= 0 )
	{
		close(drvHandle);
	}

	return result;
}
